/*
 * Created on 19-May-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AccordionSequenceDrawer;

import java.util.*;
import java.awt.Color;

/**
 * @author hilde
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Annotation {

		public final static String[] feature =  {
			"gene", "tRNA", "intron", "exon" , "repeat_region", "rRNA"
		};
	
		private final static Color col[] = {
			Color.green, Color.blue, Color.darkGray, Color.pink, Color.orange, Color.cyan
		};
			
		static int pair[] = new int[2*feature.length];
	
		public final static String[] alphabet = { 
			"intron", "exon" , "repeat_region",  "gene",// misc_features "misc_feature", "variation",
			// gene_information "CDS", "tRNA", "mRNA", "rRNA", "gene",
			"complement" // important tokens
		};

		
	
		String name;
		ArrayList ranges;
		double start, end;
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
		public Annotation( String n )
		{
			ranges = new ArrayList();
			name = n;
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
		public String getName()
		{
			return name;
		}
		
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		public void addRange( String min, String max )
		{
			int[] r = new int[2];
			
			r[0] =  Integer.parseInt( min ) -1;
			r[1] = Integer.parseInt( max ) -1;
			ranges.add( r ); 
		}
		
		public ArrayList getRanges()
		{
			return ranges;
		}
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		public static Color getColor( String str )
		{
			for( int i = 0; i<feature.length; i++)
			{
				if( str.equalsIgnoreCase( feature[i]) )
					return col[i];
			}
			return null;
		}
		
		public static void setColor( Color c, String str )
		{
			System.out.println(" color " + c +" " + str );
			for( int i = 0; i<feature.length; i++)
			{
				if( str.equalsIgnoreCase( feature[i]) )
					col[i] = c;
			}
		}
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/**
		 * @author hilde
		 * 
		 * sets rendering values in the sequence spot for every annotation
		 */
		
		public void setStartDrawingValue( double s )
		{
			start = s;
		}
		public void setEndDrawingValue( double e )
		{
			end = e;
		}
		public double getStartDrawingValue()
		{
			return start;
		}
		public double getEndDrawingValue()
		{
			return end;
		}
		
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/**
		 * group stuff
		 * @author hilde
		 *
		 */
		public static void setGroupByName( String str, int group )
		{
			
			for( int i=0; i<feature.length; i++)
			{
				if(str.equalsIgnoreCase(feature[i]))
				{
					// remember position in feature string and his group
					pair[2*i] = i;
					pair[2*i+1] = group;	
				}
			}
		}
		
		public static int getGroupByName( String str )
		{
			for( int i=0; i<feature.length; i++)
			{
				if(str.equalsIgnoreCase(feature[i]))
				{
					return pair[ 2*i+1 ];
				}
			}
			return -1; // not found
		}
}
