
/*
   Copyright (c) 2002 Compaq Computer Corporation
   
   SOFTWARE RELEASE
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
   
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   
   - Neither the names of Compaq Research, Compaq Computer Corporation
     nor the names of its contributors may be used to endorse or promote
     products derived from this Software without specific prior written
     permission.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
   IN NO EVENT SHALL COMPAQ COMPUTER CORPORATION BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
   OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
   THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

package AccordionSequenceDrawer;



/**
 * A class representing a RangeList in a RangeTree.
 *
 *
 */

public class ColorNode 

{
    /** this will hold the data */
    private RangeInSequence Data=null;

    /** left child of the current node */
    private ColorNode lc=null;
    /** right child of the current node */
    private ColorNode rc=null; 

    /** empty constructor */
    public ColorNode() 	{;} 
	
    /** constructor with Data initiated */
    public ColorNode(RangeInSequence d, ColorNode leftChild, ColorNode rightChild)
    {
    	Data = d;
    	lc = leftChild;
    	rc = rightChild;
    }

    /** @return true if the node is a leaf, false otherwise */
    public boolean childless() {
		return (lc==null) && (rc==null);
    }
	
    void setData(RangeInSequence d) { Data=d; }
	
    RangeInSequence getData() { return Data; }
    
    ColorNode getLc() { return lc; }
	
    ColorNode getRc() { return rc; }
	
    void setLeft(ColorNode O) { lc=O; }
    
    void setRight(ColorNode O) { rc=O; }
    
    public String toString()
    {
    	String left ="", right = "";
    	if (lc == null && rc == null)
    		return Data.toString();
    	if (lc != null)
    		left = lc.toString() + ", ";
    	if (rc != null)
    		right = rc.toString();
    	return Data +"(" + left + right + ")";
    }

};











