/*
 * Created on 23-Feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AccordionSequenceDrawer;

import java.util.Iterator;
import java.util.*;
import SequenceJuxtaposer.*;

/**
 * @author hilde
 *
 * makes life easier to cycle through the arraylist of strings that
 * contain the sequence data
 * very specialist iterator, can give you substrings, single characters etc.
 */

public class SequenceStringIterator implements Iterator
{

	int position = 0;
	ArrayList seqStrings;
	int maxSize;
	/**
	 * 
	 */
	public SequenceStringIterator( ArrayList seqStrings) 
	{
		super();
		this.seqStrings = seqStrings;
		maxSize = seqStrings.size() * SequenceJuxtaposer.MAX_STRING_LEN;;
	}
	
	/*
	 * we never want to remove elements of the arraylist - does nothing
	 *  see removeAtPosition to remove single chars for gap saving
	 * @see java.util.Iterator#remove()
	 */
	public void remove()
	{
		
	}

	/* (non-Javadoc)
	 * @see java.util.Iterator#hasNext()
	 */
	public boolean hasNext() 
	{
		if( position < seqStrings.size() )
			return true;
		else
			return false;
		
	}

	/* get next element from the arraylist
	 * @see java.util.Iterator#next()
	 */
	public Object next()
	{
		if( hasNext() )
			return readNextSubstring();
		else
			return null;
	}
	
	public Object prev()
	{
		if (hasPrev())
			return readPrevSubstring();
		else
			return null;
	}
	
	public boolean hasPrev()
	{
		return position > 0;
	}
	
	private Object readPrevSubstring()
	{
		Object o =  seqStrings.get(position);
		position--;
		return o;
	}
	
	/*
	 * read next element in the arraylist if position is not the end
	 */
	private Object readNextSubstring()
	{
		Object o =  seqStrings.get(position);
		position++;
		return o;
	}
	
	public int getNumOfChars()
	{
		int max = 0;
		//System.out.println("um  ");
		for( int i = 0; i < seqStrings.size() ; i++)
				   max += ((String)seqStrings.get(i)).length();
		return max;
	}
	
//	public int getSubStringSize()
//	{
//		return SequenceJuxtaposer.MAX_STRING_LEN;
//	}
	
	public int arrayLength()
	{
		return seqStrings.size();
	}
	
	public String getSubStringByPosition(int pos)
	{
		return (String)seqStrings.get(pos); 
	}
	
	public String stringAt(int position) // single letter string (node name)
	{
		if( position > maxSize)
		{		
			return null;
		}
		int index = position % SequenceJuxtaposer.MAX_STRING_LEN;
		return ((String)seqStrings.get( position/SequenceJuxtaposer.MAX_STRING_LEN )).
			substring( index, index+1 ); 
		
	}
	
	public char charAt( int position )
	{
		if( position > maxSize)
			return 0;
		return ((String)seqStrings.get( position/SequenceJuxtaposer.MAX_STRING_LEN )).charAt( position % SequenceJuxtaposer.MAX_STRING_LEN ); 
	}
	
	public int getPosInArray(int position)
	{
		int pos =(int) Math.ceil( position / SequenceJuxtaposer.MAX_STRING_LEN );
		return pos;
	}
	
	public void removeAtPosition(int array, int currentPos, int count)
	{
			//int elements =(int) Math.ceil( position / getSubStringSize() );
			int p = 0;
			//if( position > (seqStrings.size() * getSubStringSize()))
			//{		
				//throw new OutOfBoundsException( " position is not avaible in the sequence data");
			//	return;
			//}
			
			//int currentPos =  getPosInArray( position );
			//int pos = position - currentPos * getSubStringSize(); 
			//int posEnd = ((String)seqStrings.get( currentPos )).length();
			
			String arrayStr = ((String)seqStrings.get( array ));
			
			String str = arrayStr.substring(0, currentPos) + arrayStr.substring(currentPos + count); 
			
			seqStrings.set( array, str );
			//rebuildArrayList();
	
	}
		
	public void rebuildArrayList()
	{
		StringBuffer sb = new StringBuffer();
		int stop = arrayLength(); // do it before
		for( int i=0; i < stop; i++)
		{
				sb.append( (String)seqStrings.get(0));
				seqStrings.remove(0);
		}
		
		int steps =(int) Math.ceil( sb.length() / SequenceJuxtaposer.MAX_STRING_LEN ) + 1;
		for( int i = 0; i<steps; i++)
		{
			if( sb.length() > SequenceJuxtaposer.MAX_STRING_LEN ) 
			{
				seqStrings.add( sb.substring( 0, SequenceJuxtaposer.MAX_STRING_LEN ) );
				sb.delete( 0, SequenceJuxtaposer.MAX_STRING_LEN );
			}
			else 
			{
				seqStrings.add( sb.substring( 0, sb.length() ) );
				sb.delete( 0, sb.length() );	
			}
		} 
		
	}
		
	/*
	 * add String at the end
	 */
	public void add(String s)
	{
		String endString  = ((String)seqStrings.get( arrayLength() -1 ));
		
		if( endString.length() + s.length() <= SequenceJuxtaposer.MAX_STRING_LEN )
		{
			endString += s;
			seqStrings.remove(arrayLength() -1);
			seqStrings.add( endString );
		}
		else
		{
			// fill up endString
			endString += s.substring( 0, SequenceJuxtaposer.MAX_STRING_LEN - endString.length() );
			s = s.substring(SequenceJuxtaposer.MAX_STRING_LEN - endString.length());
			addString( s );
		}
	}
		
	private void addString( String s )
	{
		while( s.length() > SequenceJuxtaposer.MAX_STRING_LEN )
		{
			seqStrings.add( s.substring( 0, SequenceJuxtaposer.MAX_STRING_LEN ) );
			s = s.substring(SequenceJuxtaposer.MAX_STRING_LEN);
		}
		if( s.length() != 0 )
			seqStrings.add( s.substring( 0, s.length() ) );
	}
	

}
