/*
 * Created on 11-Dec-2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AccordionSequenceDrawer;

import java.awt.Color;

import SequenceJuxtaposer.SequenceJuxtaposer;

import AccordionDrawer.AccordionDrawer;
import AccordionDrawer.CellGeom;
import AccordionDrawer.GridCell;

import gl4java.*;

/**
 * @author hilde
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SiteNode implements CellGeom, Cloneable {

	/**
	 * @param ad
	 * @param position
	 * @param seq
	 * @param horiz
	 */
	int position;
	Sequence seq;


	int framenum; // the cached frame number	

	public GridCell cell; // where we're attached

    public Object clone() { try {return  super.clone();} catch (CloneNotSupportedException e) {return null;} }

	public SiteNode(int position, Sequence seq) {

		this.seq = seq;
		this.position = position;
		framenum = 0;
	}

	public Sequence getSequence()
	{
		return seq;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getKey()
	 */
	public int getKey() {
	    return position;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getName()
	 */
	public String getName() {
		return seq.getNodeName(position);
	}
	
	public String getLabel() {
		String name = seq.getNodeName(position);
		if (!name.equalsIgnoreCase("-"))
			return name.toUpperCase();
		return "";
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#drawInCell(java.awt.Color, float, AccordionDrawer.AccordionDrawer)
	 */
	public void drawInCell(Color col, double plane) {

		AccordionSequenceDrawer ad = (AccordionSequenceDrawer)cell.drawer;
		int X = AccordionDrawer.X;
		int Y = AccordionDrawer.Y;		
	    GridCell.incrementCountBBoxDraw();
		//System.out.println("drawing in cell " + this);
		
		if (col == null)
			col = getSiteColor();
			
		boolean drawingDiff = false, drawingFound = false;
		boolean drawingGap = isGap();
		
		int alpha = col.getAlpha(); // can't use alpha directly to get the group  :(
		col = new Color(col.getRed(), col.getGreen(), col.getBlue()); // clear alpha
		drawingDiff = col.equals(Sequence.diffColor) && alpha != 255 && cell.drawer.showdiffs;
		drawingFound = col.equals(Sequence.foundColor) && alpha != 255;

		// annotations		
		int numAnnotations = seq.getAnnotationList().size();
		
		boolean annotations[] = new boolean[numAnnotations];
		for(int i=0; i<numAnnotations; i++)
		{
			annotations[i] = col.equals(Annotation.getColor( ((Annotation)seq.annotationList.get(i)).getName() )) && alpha != 255;
		}
	
				
		// check if exon or intron are true - if yes, ask rangeinsequence at position, if complement or not
			
		Color siteColor = getSiteColor();
//		Color corSiteColor = getCorrespondingSiteColor();
		// compute cell bounds here, not caching them in gridcell turned out too slow for rendering
		double cellMin[] = {cell.getMin(0), cell.getMin(1)};
		double cellMax[] = {cell.getMax(0), cell.getMax(1)};
		
		int cellMinPix[] = {cell.drawer.w2s(cellMin[0], 0), cell.drawer.w2s(cellMin[1], 1)};
		int cellMaxPix[] = {cell.drawer.w2s(cellMax[0], 0), cell.drawer.w2s(cellMax[1], 1)};
		
		if (ad.nogeoms)
			return;
		AccordionSequenceDrawer.countDrawnFrame++;
		GLFunc gl = (GLFunc) ad.getGraphicsStuff();
		
		gl.glEnable(gl.GL_DEPTH_TEST);
		gl.glDepthFunc(gl.GL_LEQUAL);
		
		if ((ad.dimcolors || ad.dimbrite) && !drawingDiff) { // adjust saturation and brightness
			float rgbcol[] = new float[3];
			col.getRGBColorComponents(rgbcol);
			float hsbcol[] =
				Color.RGBtoHSB(
					(int) (rgbcol[0] * 255),
					(int) (rgbcol[1] * 255),
					(int) (rgbcol[2] * 255),
					(new float[3]));
			double howdim;
			// H stays the same

			// if started out greyscale, don't crank up S
			if (hsbcol[1] > 0f && ad.dimcolors) {
				// depends on size of your own screen area
				// howdim base: one pixel 0, fullscreen 1.0
				howdim = (cellMax[X] - cellMin[X]) / ad.getWinMax(X);
				//screen coords
				// small dynamic range:, 0%=.5, 20% and up =1.0
				howdim = 0.8f + howdim;
				howdim = (howdim > 1.0) ? 1.0f : howdim;
				hsbcol[1] = (float) howdim > hsbcol[1] ? hsbcol[1] : (float)howdim; // no more saturated than original color
			}

			if (ad.dimbrite && col == siteColor && !drawingGap && !drawingDiff 
				&& !checkAnnotations(numAnnotations, annotations)) { // normal draw, not in a group
				
				
				// depends on depth in tree
				int treeheight =
					((AccordionSequenceDrawer) ad).getSequence(0).getHeight();
				// howdim ranges from 0 at root to 1.0 at leaf
				howdim = 1.0f;
				// compress the range
				hsbcol[2] = (float) (0.2 + howdim * .7);
			}
			Color newrgb = Color.getHSBColor(hsbcol[0], hsbcol[1], hsbcol[2]);
			ad.setColorGL(newrgb);
		}
		
		// draw the line
		float thick = ad.linethickness;
		gl.glPolygonMode(GLEnum.GL_FRONT_AND_BACK, GLEnum.GL_FILL);
		float boxadjustfraction = .05f;
		double boxadjustsize = (cellMax[Y] - cellMin[Y])*boxadjustfraction;
		double realmin[] = new double[2];
		double realmax[] = new double[2];

		for (int xy = 0; xy < 2; xy++) {
			int minCellDims = ad.getMinCellDims(xy);
		    if (cellMaxPix[xy] - cellMinPix[xy] <= minCellDims) {
			realmax[xy] = cellMin[xy]+ad.s2w(minCellDims, xy);
			realmin[xy] = cellMin[xy];
		    } else {
			realmax[xy] = cellMax[xy];
			realmin[xy] = cellMin[xy];
		    }
		}
		ad.setColorGL(col);

		// calculate annotation sizes
		int minW[] = {2, 1}; // from 1/3 to 2/3 down from top
		int maxW[] = {1, 2};
		
		double maxV = ((minW[0]*(realmin[Y]+boxadjustsize) + maxW[0]*realmax[Y]))/(minW[0]+maxW[0]);
		double minV =  ((minW[1]*(realmin[Y]+boxadjustsize) + maxW[1]*realmax[Y]))/(minW[1]+maxW[1]);
		float height = (float)Math.abs(minV - maxV) / SequenceJuxtaposer.maxAnnotationNum;
		double start = minV;
		
		computeAnnotationSizes(numAnnotations, start, height);

		if (!col.equals(siteColor) && drawingDiff) // draw diff
		{
			int min[] = {1, 2}; // from top 0 to 1/3 down from top
			int max[] = {0, 1};
			thick += 1; //2
			gl.glLineWidth((float)thick);
			gl.glPolygonMode(GLEnum.GL_FRONT_AND_BACK, GLEnum.GL_LINE);
			gl.glBegin(GLEnum.GL_QUADS);
			
			// render only 1/3 of the cell as marked
			gl.glVertex3d(cellMin[X], ((min[0]*(realmin[Y]+boxadjustsize) + max[0]*realmax[Y]))/(min[0]+max[0]), plane);
			gl.glVertex3d(cellMin[X], ((min[1]*(realmin[Y]+boxadjustsize) + max[1]*realmax[Y]))/(min[1]+max[1]), plane);
			gl.glVertex3d(cellMax[X], ((min[1]*(realmin[Y]+boxadjustsize) + max[1]*realmax[Y]))/(min[1]+max[1]), plane);
			gl.glVertex3d(cellMax[X], ((min[0]*(realmin[Y]+boxadjustsize) + max[0]*realmax[Y]))/(min[0]+max[0]), plane);
			// render the whole cell as marked
//			gl.glVertex3d(cellMin[X], realmin[Y] + boxadjustsize, plane);
//			gl.glVertex3d(cellMin[X], realmax[Y] - boxadjustsize, plane);
//			gl.glVertex3d(cellMax[X], realmax[Y] - boxadjustsize, plane);
//			gl.glVertex3d(cellMax[X], realmin[Y] + boxadjustsize, plane);
			gl.glEnd();
		}
		else if (!col.equals(siteColor) && drawingFound) // drawfound
		{
			int min[] = {2, 1}; // from 1/3 to 2/3 down from top
			int max[] = {1, 2};
			thick += 1; //2
			gl.glLineWidth(thick);
			gl.glPolygonMode(GLEnum.GL_FRONT_AND_BACK, GLEnum.GL_LINE);
			gl.glBegin(GLEnum.GL_QUADS);
			gl.glVertex3d(cellMin[X], ((min[0]*(realmin[Y]+boxadjustsize) + max[0]*realmax[Y]))/(min[0]+max[0]), plane);
			gl.glVertex3d(cellMin[X], ((min[1]*(realmin[Y]+boxadjustsize) + max[1]*realmax[Y]))/(min[1]+max[1]), plane);
			gl.glVertex3d(cellMax[X], ((min[1]*(realmin[Y]+boxadjustsize) + max[1]*realmax[Y]))/(min[1]+max[1]), plane);
			gl.glVertex3d(cellMax[X], ((min[0]*(realmin[Y]+boxadjustsize) + max[0]*realmax[Y]))/(min[0]+max[0]), plane);
			gl.glEnd();
		}
		else if (!col.equals(siteColor) && numAnnotations > 0 ) // draw annotations
		{
			thick += 1; //2
			float offset = height / 10.0f;	
			for( int i =0; i<numAnnotations; i++)
			{
			   if( annotations[i] )
			   {
			   		gl.glLineWidth(thick);
					gl.glPolygonMode(GLEnum.GL_FRONT_AND_BACK, GLEnum.GL_LINE);
					gl.glBegin(GLEnum.GL_QUADS);
					gl.glVertex3d(cellMin[X], ((Annotation)seq.getAnnotationList().get(i)).getStartDrawingValue() , plane);
					gl.glVertex3d(cellMin[X], ((Annotation)seq.getAnnotationList().get(i)).getEndDrawingValue(), plane);
					gl.glVertex3d(cellMax[X], ((Annotation)seq.getAnnotationList().get(i)).getEndDrawingValue(), plane);
					gl.glVertex3d(cellMax[X], ((Annotation)seq.getAnnotationList().get(i)).getStartDrawingValue(), plane);
					gl.glEnd();
				
					start -= height-offset;
				}
			}
		}
	
		
		if (drawingDiff || drawingFound ||  checkAnnotations(numAnnotations, annotations))
		{
					
			ad.setColorGL(siteColor);
			plane = ad.getObjplane();
		}
		gl.glPolygonMode(GLEnum.GL_FRONT_AND_BACK, GLEnum.GL_FILL);
		// drawing not a line aymore - it s a quad now
		
		height = (float)(realmax[Y] - realmin[Y])/2;
		
		if( !ad.rendermode )
		{
			gl.glBegin(GLEnum.GL_QUADS);
			gl.glVertex3d(realmin[X], realmin[Y]+boxadjustsize, plane);
			gl.glVertex3d(realmin[X], realmax[Y], plane);
			gl.glVertex3d(realmax[X], realmax[Y], plane);
			gl.glVertex3d(realmax[X], realmin[Y]+boxadjustsize, plane);
			gl.glEnd();
		}
		else
		{
			gl.glBegin(GLEnum.GL_QUADS);
			gl.glVertex3d(realmin[X], realmin[Y] + height, plane);
			gl.glVertex3d(realmin[X], realmax[Y] -boxadjustsize, plane);
			gl.glVertex3d(realmax[X], realmax[Y] -boxadjustsize, plane);
			gl.glVertex3d(realmax[X], realmin[Y] + height, plane);
			gl.glEnd();
	
			// draw second DNA/RNA strang
//			ad.setColorGL(corSiteColor);
//				
//			gl.glBegin(GLEnum.GL_QUADS);
//			gl.glVertex3d(realmin[X], realmin[Y] + boxadjustsize, plane);
//			gl.glVertex3d(realmin[X], realmax[Y] - height  , plane);
//			gl.glVertex3d(realmax[X], realmax[Y] -height, plane);
//			gl.glVertex3d(realmax[X], realmin[Y] + boxadjustsize, plane);
//			gl.glEnd();
		}
		
		

		if (ad.drawlabels && getLabel().length() > 0) {
			
			drawLabelBox(((AccordionSequenceDrawer) ad).maxFontHeight, cellMinPix, cellMaxPix);
		}
		gl.glDisable(gl.GL_DEPTH_TEST);
	}

	/**
	 *  simple validity check
	 */
	boolean checkAnnotations(int numAnnotations, boolean annotations[])
	{
		for(int i = 0; i<numAnnotations; i++)
		{
				if( annotations[i] )
					return true;
		}
		return false;
		
	}
	
	/**
	 *  compute rendering size for every annotation 
	 * 
	 */
	void computeAnnotationSizes(int numAnnotations, double start, double height)
	{
		for(int i = 0; i< Annotation.feature.length; i++)
		{
			for( int j =0; j< numAnnotations; j++)
			{
				if( ((Annotation)seq.annotationList.get(j)).getName().equalsIgnoreCase(Annotation.feature[i]) )
				{
					((Annotation)seq.annotationList.get(j)).setStartDrawingValue(start);
					((Annotation)seq.annotationList.get(j)).setEndDrawingValue(start-height);
					
					start -= height;
				}
				
				
			}
				
		}
	}
	

	/** Draw a LabelBox. 
	 * @author	 Tamara Munzner, Li Zhang
	 * @param	 lb LabelBox to use
	 * @param    fontheight Size of font to use, in points/pixels.
	 */
	// cell's place has been computed in drawInCell for this frame
	private void drawLabelBox(int fontheight, int[] cellMinPix, int[] cellMaxPix) {
		AccordionSequenceDrawer d = (AccordionSequenceDrawer) cell.drawer;
		int rX = 0, X = 0;
		int rY = 1 ,Y = 1;
		if (!d.horiz) {
			X = 1;
			Y = 0;
		}
		// draw label only when namewidth < diff[X] AND fontheight < diff[Y] in vertical direction
		int diff[] = { cellMaxPix[X] - cellMinPix[X], cellMaxPix[Y] - cellMinPix[Y]};
		int namewidth = AccordionSequenceDrawer.bff.stringWidth(getLabel(), fontheight);
		if (namewidth > Sequence.maxFontLength) Sequence.maxFontLength = namewidth;
		GLFunc gl = (GLFunc) d.getGraphicsStuff();
		// multiply with the number of sequences - what a mess
		// SequenceJuxtaposer.sequenceCount is now public
		// it is all because we switched x and y, and now y is devided
		// by the number of sequences. unfortunately we use that as 
		// x. that causes trouble - 3 is a little offset
		if( namewidth  <= (diff[X] - 3) && fontheight <= (diff[Y] - 3)) {
			d.setColorGL(d.getLabelColor());
			gl.glRasterPos3d(
					 d.s2w(cellMinPix[X]+(diff[X]/2.0f)-(namewidth/2.0f),X),
					 d.s2w(cellMinPix[Y]+(diff[Y]/2.0f)+(fontheight/2.0f),Y),
					 d.getLabelplane());
		AccordionSequenceDrawer.bff.drawString(gl, getName(), fontheight);
		}
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#setCell(AccordionDrawer.GridCell)
	 */
	public void setCell(GridCell c) {
		cell =c;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getCell()
	 */
	public GridCell getCell() {
		return cell;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#pick(int, int)
	 */
	public boolean pick(int x, int y) {
		AccordionSequenceDrawer ad = (AccordionSequenceDrawer) cell.drawer;
		float posEndPix[] = new float[2];
		float posStartPix[] = new float[2];
		for (int xy = 0; xy < 2; xy++) {
			posStartPix[xy] = ad.w2s(cell.getMin(xy), xy);
			posEndPix[xy] = ad.w2s(cell.getMax(xy), xy);
		}
		if ((x > posStartPix[0] - ad.pickFuzz
			&& x < posEndPix[0] + ad.pickFuzz)
			&& (y > posStartPix[1] - ad.pickFuzz
				&& y < posEndPix[1] + ad.pickFuzz))
			return true;
		else
			return false;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getMin()
	 */
	public int getMin() {
		return position;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getMax()
	 */
	public int getMax() {
		return position;
	}
	
	public double getMin(int y) {
		return cell.getMin(y);
	}
	
	public double getMax(int y) {
		return cell.getMax(y);
	}

	public Color getSiteColor() {
		String name = getName();
		if (position == -1)
			return Sequence.gapColor;
		if (name.length() > 0)
			return Sequence.getColor( name.charAt(0));
		return Sequence.gapColor;
	}
	
//	public Color getCorrespondingSiteColor() {
//			String name = getName();
//			if (position == -1)
//				return Sequence.gapColor;
//			if (name.length() > 0)
//				return Sequence.getCorrespondingColor( name.charAt(0));
//			return Sequence.gapColor;
//		}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#setCachedFrame(int)
	 */
	public void setCachedFrame(int framenum) {
		this.framenum = framenum;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.CellGeom#getCachedFrame()
	 */
	public int getCachedFrame() {
		return framenum;
	}

	public int getPosition() {
		return position;
	}

	public String toString()
	{
		return seq + "@" + position + "(" + getName() + ")"; 
	}

	public boolean isGap()
	{
		return getName().equals("-");
	}
	
	static public boolean isGap(char c)
	{
		return (c == '-');
	}
}
