/*
 * Created on 29-Dec-2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package SequenceJuxtaposer;

import AccordionSequenceDrawer.Sequence;

import javax.swing.JFrame;
import java.awt.*;
import javax.swing.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;


/**
 * @author demo
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GroupFrame extends JFrame implements MouseListener, ActionListener {

	// groups are:
	public static final int GROUP_A = 0; // A
	public static final int GROUP_T = 1; // C
	public static final int GROUP_C = 2; // G
	public static final int GROUP_G = 3; // T
	public static final int GROUP_U = 4; // U
	
	public static final int GROUP_N = 5; // N (A, C, G, or T/U)
	public static final int GROUP_GAP = 6; // alignment space
	
	public static final int GROUP_FOUND = 7; // found group
	
	public static final int GROUP_DIFF = 8; // differences
	public static final int CHECK_DIFF = 9; // check box for differences
	
	public static final int CHECK_WILD = 10; // check for wildcards in sequences
	
	public static final int numGroups = 9;
	
	Color color[] = {Sequence.getColor('A'),
		Sequence.getColor('T'),
		Sequence.getColor('C'),
		Sequence.getColor('G'),
		Sequence.getColor('U'),
		Sequence.getColor('N'),
		Sequence.getColor('-'),
		Sequence.getColor('F'),
		Sequence.getColor('X'),
		};
	Canvas swatch[] = new Canvas[numGroups];
	private final int CANVAS_SIZE = 15;
	
	String name[] = {"A", "T", "C", "G", "U", "N", "Gaps", "Search", "Differences", "Differences", "Wildcard in search"};
	JLabel label[] = {new JLabel(name[GROUP_A]),
		new JLabel(name[GROUP_T]),
		new JLabel(name[GROUP_C]),
		new JLabel(name[GROUP_G]),
		new JLabel(name[GROUP_U]),
		new JLabel(name[GROUP_N]),
		new JLabel(name[GROUP_GAP]),
		new JLabel(name[GROUP_FOUND]),
		new JLabel(name[GROUP_DIFF]),
		new JLabel(name[CHECK_DIFF]),
		new JLabel(name[CHECK_WILD])
		};

	static final private String colorTitle[] = {
		"'A' color selection",
		"'T' color selection",
		"'C' color selection",
		"'G' color selection",
		"'U' color selection",
		"'N' color selection",
		"'Gap' color selection",
		"'Search' color selection",
		"'Differences' color selection"
	};
	
	JRadioButton select[] = new JRadioButton[numGroups]; // check box indicates group is selected to grow/shrink
	private ButtonGroup selectGroup;
	
	JCheckBox diffOn = new JCheckBox();
	JCheckBox wildOn = new JCheckBox();
	
	
	
	String buttonName[] = { "Smaller", "Bigger", "Reset", "Clear" };
	JButton resize[] = new JButton[4]; // grow/shrink/reset/clear
		
	SequenceJuxtaposer sj; // parent window
		
	public GroupFrame(SequenceJuxtaposer sj)
	{
		this.sj = sj;
		initComponents();
		addMouseListener(this);
	}

	public void initComponents()
	{
		int componentsPerRow = 6;
		selectGroup = new ButtonGroup();
		getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints gc = new GridBagConstraints();
		for (int i = 0; i < numGroups; i++)
		{
			JPanel canvasPanel = new JPanel();
			canvasPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

			swatch[i] = new Canvas();
			swatch[i].setSize(CANVAS_SIZE, CANVAS_SIZE);
			swatch[i].setBackground(color[i]);
			swatch[i].addMouseListener(this);
			//System.out.println(color[i].getRed() + " " + color[i].getGreen() + " " + color[i].getBlue());
			canvasPanel.add(swatch[i]);

			
			gc.gridy = i/componentsPerRow;
			gc.gridx = (i % componentsPerRow) * 4;
			getContentPane().add(canvasPanel, gc);
			
			gc.gridx++;
			if (i == GROUP_GAP || i == GROUP_DIFF || i == GROUP_FOUND)
			{
				selectGroup.add(select[i]);
				select[i] = new JRadioButton();
				select[i].setSelected(false);
				select[i].addActionListener(this);
				getContentPane().add(select[i], gc);
			}
			
			gc.gridx++;
			gc.anchor = GridBagConstraints.WEST;
			if (i == GROUP_DIFF)
				gc.gridwidth = 2;
			getContentPane().add(label[i], gc);
			gc.anchor = GridBagConstraints.CENTER;
			gc.gridwidth = 1;
			
			gc.gridx++;
			//if (i % componentsPerRow < (componentsPerRow - 1))
			{
				gc.ipadx = 10;
				getContentPane().add(new JPanel(), gc);
				gc.ipadx = 0;
			}
		}
		
		gc.gridx+=2;
		diffOn.addActionListener(this);
		getContentPane().add(diffOn, gc);
		gc.gridx++;
		gc.gridwidth = 4;
		getContentPane().add(label[CHECK_DIFF], gc);
		gc.gridwidth = 1;
		
		gc.gridx+=4;
		wildOn.addActionListener(this);
		getContentPane().add(wildOn, gc);
		//gc.gridx++;
		gc.gridwidth = 5;
		getContentPane().add(label[CHECK_WILD], gc);
		gc.gridwidth = 1;
		
		
		
		gc.gridy = 3;
		gc.ipady = 5;
		getContentPane().add(new JPanel(), gc);
		gc.ipady = 0;
		gc.gridy++;
		gc.gridwidth = 4;
		gc.anchor = GridBagConstraints.WEST;
		for (int i = 0; i < 2; i++)
		{
			gc.gridx = 8 + i * 4;
			resize[i] = new JButton(buttonName[i]);
			resize[i].addActionListener(this);
			getContentPane().add(resize[i], gc);
		}
		gc.gridx = 0;
		resize[2] = new JButton(buttonName[2]);
		resize[2].addActionListener(this);
		getContentPane().add(resize[2], gc);
		gc.gridx = 4;
		resize[3] = new JButton(buttonName[3]);
		resize[3].addActionListener(this);
		getContentPane().add(resize[3], gc);
		
		selectGroup.setSelected(select[GROUP_GAP].getModel(), true);
		select[GROUP_GAP].setSelected(true);
		diffOn.setSelected(true);
		wildOn.setSelected(true);
		
		pack();
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		Object obj = e.getSource();
		int group = -1;
		int tjgroup = -1;
		if (obj == swatch[GROUP_A])
			{ group = GROUP_A; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_A]; }
		else if (obj == swatch[GROUP_T])
			{ group = GROUP_T; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_T]; }
		else if (obj == swatch[GROUP_C])
			{ group = GROUP_C; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_C]; }
		else if (obj == swatch[GROUP_G])
			{ group = GROUP_G; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_G]; }
		else if (obj == swatch[GROUP_U])
			{ group = GROUP_U; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_U]; }
		else if (obj == swatch[GROUP_N])
			{ group = GROUP_N; tjgroup = SequenceJuxtaposer.siteGroup[GROUP_N]; }
		else if (obj == swatch[GROUP_GAP])
			{ group = GROUP_GAP; tjgroup = SequenceJuxtaposer.gapGroup; }
		else if (obj == swatch[GROUP_DIFF])
			{ group = GROUP_DIFF; tjgroup = SequenceJuxtaposer.diffGroupMark; }
		else if (obj == swatch[GROUP_FOUND])
			{ group = GROUP_FOUND; tjgroup = SequenceJuxtaposer.foundGroupMark; }
	 
		if (group < 0) return;
			Color newColor = JColorChooser.showDialog(this, colorTitle[group], color[group]);
			if (newColor != null)
			{
				if (group == GROUP_A || group == GROUP_T || group == GROUP_C || group == GROUP_G ||
					group == GROUP_U || group == GROUP_N)
					Sequence.setColor(Sequence.letter[group], newColor);
				else if (group == GROUP_GAP)
					Sequence.gapColor = newColor;
				else if (group == GROUP_DIFF)
					Sequence.diffColor = newColor;
				else if (group == GROUP_FOUND)
					Sequence.foundColor = newColor;
//				else if (group == GROUP_REPEAT)
//					Sequence.repeatColor = newColor;
//				else if (group == GROUP_EXON)
//					Sequence.exonColor = newColor;
//				else if (group == GROUP_INTRON)
//					Sequence.intronColor = newColor;
				color[group] = newColor;
				swatch[group].setBackground(color[group]);
				sj.setGroupColor(tjgroup, color[group]); // for differences and gaps
				sj.requestRedrawAll();
				sj.changedMarks();
			}
		}

	public void mouseEntered(MouseEvent e) {	}
	public void mouseExited(MouseEvent e) {	}
	public void mousePressed(MouseEvent e) {	}
	public void mouseReleased(MouseEvent e) {	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
//		System.out.println("Action: " + e);
		if (e.getSource() instanceof JRadioButton)
		{
			JRadioButton button = (JRadioButton)e.getSource();
			selectGroup.setSelected(button.getModel(), true);
			button.setSelected(true);
		}
		else if (e.getSource() instanceof JButton)
		{
			JButton button = (JButton)e.getSource();
			AccordionSequenceDrawerFinal asd = sj.asd;
			if (button == resize[0]) // smaller
			{
//				tj.resizeGroup(atd.getActionGroup(), growBigger, numSteps, horiz, vert, atd);
				if (select[GROUP_GAP].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.gapGroup, false, asd.getNumAnimSteps());
				else if (select[GROUP_DIFF].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.diffGroupDraw, false, asd.getNumAnimSteps());
				else if (select[GROUP_FOUND].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.foundGroupDraw, false, asd.getNumAnimSteps());
//				else if (select[GROUP_REPEAT].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.repeatGroupDraw, false, asd.getNumAnimSteps());
//				else if (select[GROUP_EXON].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.exonGroupDraw, false, asd.getNumAnimSteps());
//				else if (select[GROUP_INTRON].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.intronGroupDraw, false, asd.getNumAnimSteps());
			}
			else if (button == resize[1]) // bigger
			{
				if (select[GROUP_GAP].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.gapGroup, true, asd.getNumAnimSteps());
				else if (select[GROUP_DIFF].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.diffGroupDraw, true, asd.getNumAnimSteps());
				else if (select[GROUP_FOUND].isSelected())
					sj.resizeGroup(SequenceJuxtaposer.foundGroupDraw, true, asd.getNumAnimSteps());
//				else if (select[GROUP_REPEAT].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.repeatGroupDraw, true, asd.getNumAnimSteps());
//				else if (select[GROUP_EXON].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.exonGroupDraw, true, asd.getNumAnimSteps());
//				else if (select[GROUP_INTRON].isSelected())
//					sj.resizeGroup(SequenceJuxtaposer.intronGroupDraw, true, asd.getNumAnimSteps());
			}
			else if (button == resize[2]) // reset
			{
				sj.reset();
			}
			else if (button == resize[3]) // clear found
			{
				sj.searchString = "";
				sj.searchSequences(SequenceJuxtaposer.foundGroupDraw, SequenceJuxtaposer.foundGroupMark);
				sj.changedMarks();
				sj.requestRedrawAll();
			}
		}
		else if (e.getSource() instanceof JCheckBox)
		{
			if (e.getSource() == diffOn)
				// it's the diff toggle
				sj.setShowDiffs(diffOn.isSelected());
			else //if (e.getSource() == wildOn)
				// it's the wild toggle
				sj.setWildOn(wildOn.isSelected());
		}
	}

	

}
